unit AddColor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TfrmAddColor = class(TForm)
    ColorDialog1: TColorDialog;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label4: TLabel;
    Bevel1: TBevel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
  public
    CurIndex: Integer;

    procedure UpdateColor(Color: TColor);
  end;

var
  frmAddColor: TfrmAddColor;

implementation

uses Main;

{$R *.dfm}

procedure TfrmAddColor.Button1Click(Sender: TObject);
begin
  ModalResult := idCancel;
end;

procedure TfrmAddColor.Button2Click(Sender: TObject);
begin
  ModalResult := idOk;
end;

procedure TfrmAddColor.UpdateColor(Color: TColor);
var
  tmp: String;
  c: array[0..5] of CHAR;
begin
  Panel1.Color := Color;
  tmp := IntToHex(Color, 6);
  c[0] := tmp[5];
  c[1] := tmp[6];
  c[2] := tmp[3];
  c[3] := tmp[4];
  c[4] := tmp[1];
  c[5] := tmp[2];
  Label1.Caption := '#' + c;
  ColorDialog1.Color := Color;
end;

procedure TfrmAddColor.Label3Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
    UpdateColor(ColorDialog1.Color);
end;

procedure TfrmAddColor.Edit1Change(Sender: TObject);
var
  i: Integer;
begin
  Button2.Enabled := True;
  Label4.Caption := '';

  if (Length(Edit1.Text) > 0) then
  begin
    for i:= 0 to frmMain.ListBox1.Items.Count - 1 do
    if (CurIndex <> i) and SameText(PColorData(frmMain.ListBox1.Items.Objects[i])^.Name, Edit1.Text) then
    begin
      Button2.Enabled := False;
      Label4.Caption := '   ';
      Break;
    end;
  end else
  begin
    Button2.Enabled := False;
    Label4.Caption := ' ';
  end;
end;

end.
