unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WinLayerFS, Menus, ComCtrls, ExtCtrls, StdCtrls, PngImage, IniFiles,
  XPMan;

type
  TfrmMain = class(TForm)
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel8: TPanel;
    Panel4: TPanel;
    ListBox1: TListBox;
    Panel5: TPanel;
    Panel6: TPanel;
    ListBox2: TListBox;
    Panel7: TPanel;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    SaveDialog: TSaveDialog;
    Splitter2: TSplitter;
    OpenDialog: TOpenDialog;
    Panel9: TPanel;
    Panel10: TPanel;
    ListBox3: TListBox;
    PopupMenu3: TPopupMenu;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    ini1: TMenuItem;
    ini2: TMenuItem;
    SaveDialogIni: TSaveDialog;
    OpenDialogIni: TOpenDialog;
    Panel11: TPanel;
    Panel12: TPanel;
    ListBox4: TListBox;
    PopupMenu4: TPopupMenu;
    N19: TMenuItem;
    N20: TMenuItem;
    N21: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure PopupMenu2Popup(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure PopupMenu3Popup(Sender: TObject);
    procedure N16Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure N17Click(Sender: TObject);
    procedure ini1Click(Sender: TObject);
    procedure ini2Click(Sender: TObject);
    procedure N20Click(Sender: TObject);
    procedure PopupMenu4Popup(Sender: TObject);
    procedure N19Click(Sender: TObject);
    procedure N21Click(Sender: TObject);
  private
  public
  end;

var
  frmMain: TfrmMain;

type
  PFontData = ^TFontData;
  TFontData = packed record
    Name: String;
    FontName: TFontName;
    FontSize: Integer;
    FontColor: TColor;
    FontStyle: TFontStyles;
  end;

  PColorData = ^TColorData;
  TColorData = packed record
    Name: String;
    Color: TColor;
  end;

  PIntData = ^TIntData;
  TIntData = packed record
    Name: String;
    Int: String;
  end;

  PImageData = ^TImageData;
  TImageData = packed record
    Name: String;
    Image: String;
  end;

implementation

uses AddColor, AddImage, Process, AddInt, AddFont;

{$R *.dfm}

function WebToColor(Color: String): TColor;
var
  i: Integer;
  e: Integer;
  Tmp: String;
begin
  Result := clNone;
  if (Length(Color) > 0) and (Length(Color) <= 7) and (Color[1] = '#') then
  begin
    Color := UpperCase(Color);
    while (Length(Color) < 7) do
      Insert('0', Color, 1);
    SetLength(Tmp, Length(Color));
    Tmp[1] := '$';
    for i:= 0 to 2 do
    begin
      Tmp[i * 2 + 2] := Color[Length(Color) - i * 2 - 1];
      Tmp[i * 2 + 3] := Color[Length(Color) - i * 2];
    end;
    val(Tmp, Result, e);
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Caption := Application.Title;
end;

procedure TfrmMain.N6Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.N8Click(Sender: TObject);
begin
  if MessageBox(Handle, '   .  ?',
    'Question', MB_YESNO) <> idYes then Exit;

  ListBox1.Clear;
  ListBox2.Clear;
  ListBox3.Clear;
  ListBox4.Clear;
end;

procedure TfrmMain.N9Click(Sender: TObject);
var
  ColorData: PColorData;
begin
  frmAddColor.CurIndex := -1;
  frmAddColor.Edit1.Text := '';
  frmAddColor.Label4.Caption := '';
  frmAddColor.Button2.Enabled := False;
  frmAddColor.UpdateColor(clBlack);
  if (frmAddColor.ShowModal = idOk) then
  begin
    new(ColorData);
    ColorData^.Name := frmAddColor.Edit1.Text;
    ColorData^.Color := frmAddColor.ColorDialog1.Color;
    ListBox1.Items.AddObject(Format('%s, %s',
      [frmAddColor.Label1.Caption, frmAddColor.Edit1.Text]), TObject(ColorData));
  end;
end;

procedure TfrmMain.N10Click(Sender: TObject);
begin
  if MessageBox(Handle, ' ?', 'Question', MB_ICONQUESTION or MB_YESNO) <> idYes then Exit;
  dispose(PColorData(ListBox1.Items.Objects[ListBox1.ItemIndex]));
  ListBox1.Items.Delete(ListBox1.ItemIndex);
end;

procedure TfrmMain.PopupMenu1Popup(Sender: TObject);
begin
  N10.Enabled := (ListBox1.ItemIndex >= 0);
  N11.Enabled := N10.Enabled;
end;

procedure TfrmMain.PopupMenu3Popup(Sender: TObject);
begin
  N16.Enabled := (ListBox3.ItemIndex >= 0);
  N17.Enabled := N16.Enabled;
end;

procedure TfrmMain.N11Click(Sender: TObject);
var
  ColorData: PColorData;
begin
  ColorData := PColorData(ListBox1.Items.Objects[ListBox1.ItemIndex]);
  frmAddColor.CurIndex := ListBox1.ItemIndex;
  frmAddColor.Edit1.Text := ColorData^.Name;
  frmAddColor.Label4.Caption := '';
  frmAddColor.Button2.Enabled := True;
  frmAddColor.UpdateColor(ColorData^.Color);
  if (frmAddColor.ShowModal = idOk) then
  begin
    ColorData^.Name := frmAddColor.Edit1.Text;
    ColorData^.Color := frmAddColor.ColorDialog1.Color;
    ListBox1.Items[ListBox1.ItemIndex] := Format('%s, %s',
      [frmAddColor.Label1.Caption, frmAddColor.Edit1.Text]);
  end;
end;

procedure TfrmMain.N12Click(Sender: TObject);
var
  ImageData: PImageData;
  Image: TPNGObject;
begin
  frmAddImage.Edit1.Text := '';
  frmAddImage.Edit2.Text := '';
  frmAddImage.Label4.Caption := '';
  frmAddImage.Button2.Enabled := False;
  if (frmAddImage.ShowModal = idOk) then
  begin
    Image := TPNGObject.Create;
    try
      Image.LoadFromFile(frmAddImage.Edit2.Text);
      Image.Free;
    except
      Image.Free;
      MessageBox(Handle, '   !', 'Error', MB_ICONERROR);
      Exit;
    end;

    new(ImageData);
    ImageData^.Name := frmAddImage.Edit1.Text;
    ImageData^.Image := frmAddImage.Edit2.Text;
    ListBox2.Items.AddObject(Format('%s, "%s"',
      [frmAddImage.Edit1.Text, frmAddImage.Edit2.Text]), TObject(ImageData));
  end;
end;

procedure TfrmMain.N14Click(Sender: TObject);
var
  ImageData: PImageData;
begin
  ImageData := PImageData(ListBox2.Items.Objects[ListBox2.ItemIndex]);
  frmAddImage.Edit1.Text := ImageData^.Name;
  frmAddImage.Edit2.Text := ImageData^.Image;
  frmAddImage.Label4.Caption := '';
  frmAddImage.Button2.Enabled := True;
  if (frmAddImage.ShowModal = idOk) then
  begin
    ImageData^.Name := frmAddImage.Edit1.Text;
    ImageData^.Image := frmAddImage.Edit2.Text;
    ListBox2.Items[ListBox2.ItemIndex] := Format('%s, "%s"',
      [frmAddImage.Edit1.Text, frmAddImage.Edit2.Text]);
  end;
end;

procedure TfrmMain.N13Click(Sender: TObject);
begin
  if MessageBox(Handle, ' ?', 'Question', MB_ICONQUESTION or MB_YESNO) <> idYes then Exit;
  dispose(PImageData(ListBox2.Items.Objects[ListBox2.ItemIndex]));
  ListBox2.Items.Delete(ListBox2.ItemIndex);
end;

procedure TfrmMain.PopupMenu2Popup(Sender: TObject);
begin
  N13.Enabled := (ListBox2.ItemIndex >= 0);
  N14.Enabled := N13.Enabled;
end;

procedure TfrmMain.N5Click(Sender: TObject);
var
  fs: TWinLayerFS;
  i: Integer;
begin
  if SaveDialog.Execute then
  begin
    frmProcess.Show;
    frmProcess.Caption := '...';
    frmProcess.Label1.Caption := '';
    frmProcess.Label2.Caption := '0%';
    frmProcess.ProgressBar1.Min := 0;
    frmProcess.ProgressBar1.Max := ListBox1.Items.Count + ListBox2.Items.Count
      + ListBox3.Items.Count + ListBox4.Items.Count;
    frmProcess.ProgressBar1.Position := 0;
    frmProcess.ProgressBar1.Step := 1;

    try
      fs := TWinLayerFS.Create(ChangeFileExt(SaveDialog.FileName, '.wls'), False);

      for i:= 0 to ListBox1.Items.Count - 1 do
      begin
        with PColorData(ListBox1.Items.Objects[i])^ do
          fs.AddColor(Name, Color);

        frmProcess.ProgressBar1.StepIt;
        frmProcess.Label1.Caption := PColorData(ListBox1.Items.Objects[i])^.Name;
        with frmProcess.ProgressBar1 do
          frmProcess.Label2.Caption := Format('%d%%', [Position div Max]);
        Application.ProcessMessages;
      end;

      for i:= 0 to ListBox2.Items.Count - 1 do
      begin
        with PImageData(ListBox2.Items.Objects[i])^ do
          fs.AddImage(Name, Image);
          
        frmProcess.ProgressBar1.StepIt;
        frmProcess.Label1.Caption := PImageData(ListBox2.Items.Objects[i])^.Name;
        with frmProcess.ProgressBar1 do
          frmProcess.Label2.Caption := Format('%d%%', [Position div Max]);
        Application.ProcessMessages;
      end;

      for i:= 0 to ListBox3.Items.Count - 1 do
      begin
        with PIntData(ListBox3.Items.Objects[i])^ do
          fs.AddInt(Name, Int);

        frmProcess.ProgressBar1.StepIt;
        frmProcess.Label1.Caption := PIntData(ListBox3.Items.Objects[i])^.Name;
        with frmProcess.ProgressBar1 do
          frmProcess.Label2.Caption := Format('%d%%', [Position div Max]);
        Application.ProcessMessages;
      end;

      for i:= 0 to ListBox4.Items.Count - 1 do
      begin
        with PFontData(ListBox4.Items.Objects[i])^ do
          fs.AddFont(Name, FontName, FontSize, FontColor, FontStyle);

        frmProcess.ProgressBar1.StepIt;
        frmProcess.Label1.Caption := PFontData(ListBox4.Items.Objects[i])^.Name;
        with frmProcess.ProgressBar1 do
          frmProcess.Label2.Caption := Format('%d%%', [Position div Max]);
        Application.ProcessMessages;
      end;

      fs.Free;
    finally
    end;

    frmProcess.Hide;
  end;
end;

procedure TfrmMain.N4Click(Sender: TObject);
var
  fs: TWinLayerFS;
  i: Integer;
  ColorData: PColorData;
  IntData: PIntData;
  FontData: PFontData;
  ImageData: PImageData;
  TmpDir: String;
begin
  if OpenDialog.Execute then
  begin
    ListBox1.Clear;
    ListBox2.Clear;
    ListBox3.Clear;
    ListBox4.Clear;

    frmProcess.Show;
    frmProcess.Caption := '...';
    frmProcess.Label1.Caption := '';
    frmProcess.Label2.Caption := '0%';
    frmProcess.ProgressBar1.Min := 0;
    frmProcess.ProgressBar1.Max := 0;
    frmProcess.ProgressBar1.Position := 0;

    TmpDir := ExtractFilePath(ParamStr(0)) + 'Temp\';
    CreateDir(TmpDir);

    try
      fs := TWinLayerFS.Create(OpenDialog.FileName, True);
      frmProcess.ProgressBar1.Max := fs.Count;

      for i:= 0 to fs.Count - 1 do
      begin
        case fs.Item[i].dwType of
          WinLayerTypeFont:
          begin
            new(FontData);
            FontData^.Name := fs.Item[i].dwName;
            with PWinLayerFSFont(fs.Item[i].dwData)^ do
            begin
              FontData^.FontName := Name;
              FontData^.FontSize := Size;
              FontData^.FontColor := Color;
              FontData^.FontStyle := BinToFontStyles(Style);
            end;
            ListBox4.Items.AddObject(Format('%s, %s, %d',
              [FontData^.Name, FontData^.FontName, FontData^.FontSize]), TObject(FontData));
          end;
          
          WinLayerTypeInt:
          begin
            new(IntData);
            IntData^.Name := fs.Item[i].dwName;
            IntData^.Int := PString(fs.Item[i].dwData)^;
            ListBox3.Items.AddObject(Format('%s, "%s"',
              [IntData^.Name, IntData^.Int]), TObject(IntData));
          end;
          
          WinLayerTypeColor:
          begin
            new(ColorData);
            ColorData^.Name := fs.Item[i].dwName;
            ColorData^.Color := PColor(fs.Item[i].dwData)^;
            frmAddColor.UpdateColor(ColorData^.Color);
            ListBox1.Items.AddObject(Format('%s, %s',
              [frmAddColor.Label1.Caption, ColorData^.Name]), TObject(ColorData));
          end;

          WinLayerTypeImage:
          begin
            new(ImageData);
            ImageData^.Name := fs.Item[i].dwName;
            ImageData^.Image := Format('%s%s.png', [TmpDir, ImageData^.Name]);
            fs.Prepare(i, True); // load png to data
            TPNGObject(fs.Item[i].dwData).SaveToFile(ImageData^.Image);
            fs.Prepare(i, False); // unload png from data
            ListBox2.Items.AddObject(Format('%s, "%s"',
              [ImageData^.Name, ImageData^.Image]), TObject(ImageData));  
          end;
        end;

        frmProcess.ProgressBar1.Position := i + 1;
        frmProcess.Label1.Caption := fs.Item[i].dwName;
        with frmProcess.ProgressBar1 do
          frmProcess.Label2.Caption := Format('%d%%', [Position div Max]);
        Application.ProcessMessages;      
      end;

      fs.Free;
    finally
    end;

    frmProcess.Hide;
  end;
end;

procedure TfrmMain.N16Click(Sender: TObject);
begin
  if MessageBox(Handle, ' ?', 'Question', MB_ICONQUESTION or MB_YESNO) <> idYes then Exit;
  dispose(PIntData(ListBox3.Items.Objects[ListBox3.ItemIndex]));
  ListBox3.Items.Delete(ListBox3.ItemIndex);
end;

procedure TfrmMain.N15Click(Sender: TObject);
var
  IntData: PIntData;
begin               
  frmAddInt.CurIndex := -1;
  frmAddInt.Edit1.Text := '';
  frmAddInt.Edit2.Text := '';
  frmAddInt.Label4.Caption := '';
  frmAddInt.Button2.Enabled := False;
  if (frmAddInt.ShowModal = idOk) then
  begin
    new(IntData);
    IntData^.Name := frmAddInt.Edit1.Text;
    IntData^.Int := frmAddInt.Edit2.Text;  
    ListBox3.Items.AddObject(Format('%s, "%s"',
      [frmAddInt.Edit1.Text, frmAddInt.Edit2.Text]), TObject(IntData));
  end;
end;

procedure TfrmMain.N17Click(Sender: TObject);
var
  IntData: PIntData;
begin
  IntData := PIntData(ListBox3.Items.Objects[ListBox3.ItemIndex]);
  frmAddInt.CurIndex := ListBox3.ItemIndex;
  frmAddInt.Edit1.Text := IntData^.Name;
  frmAddInt.Edit2.Text := IntData^.Int;
  frmAddInt.Label4.Caption := '';
  frmAddInt.Button2.Enabled := True;
  if (frmAddInt.ShowModal = idOk) then
  begin
    IntData^.Name := frmAddInt.Edit1.Text;
    IntData^.Int := frmAddInt.Edit2.Text;
    ListBox3.Items[ListBox3.ItemIndex] := Format('%s, "%s"',
      [frmAddInt.Edit1.Text, frmAddInt.Edit2.Text]);
  end;
end;

procedure TfrmMain.ini1Click(Sender: TObject);

function StrToFontStyles(S: String): TFontStyles;
begin
  Result := [];
  S := LowerCase(S);
  if (Pos('bold', S) > 0) then Result := Result + [fsBold];
  if (Pos('italic', S) > 0) then Result := Result + [fsItalic];
  if (Pos('underline', S) > 0) then Result := Result + [fsUnderline];
  if (Pos('strikeout', S) > 0) then Result := Result + [fsStrikeout];
end;

var
  Ini: TIniFile;
  Str: TStringList;
  i: Integer;
  IntData: PIntData;
  ColorData: PColorData;
  ImageData: PImageData;
  FontData: PFontData;
begin
  if OpenDialogIni.Execute then
  begin
    ListBox1.Clear;
    ListBox2.Clear;
    ListBox3.Clear;
    ListBox4.Clear;
  
    Ini := TIniFile.Create(OpenDialogIni.FileName);
    Str := TStringList.Create;

    Ini.ReadSection('Constant', Str);
    for i:= 0 to Str.Count - 1 do
    begin
      new(IntData);
      IntData^.Name := Str[i];
      IntData^.Int := Ini.ReadString('Constant', Str[i], '0');
      ListBox3.Items.AddObject(Format('%s, "%s"',
        [IntData^.Name, IntData^.Int]), TObject(IntData));
    end;

    Ini.ReadSection('Color', Str);
    for i:= 0 to Str.Count - 1 do
    begin
      new(ColorData);
      ColorData^.Name := Str[i];
      ColorData^.Color := WebToColor(Ini.ReadString('Color', Str[i], '#0'));
      ListBox1.Items.AddObject(Format('%s, %s',
        [ColorData^.Name, Ini.ReadString('Color', Str[i], '#0')]), TObject(ColorData));
    end;

    Ini.ReadSection('Image', Str);
    for i:= 0 to Str.Count - 1 do
    begin
      new(ImageData);
      ImageData^.Name := Str[i];
      ImageData^.Image := Ini.ReadString('Image', Str[i], '');
      ListBox2.Items.AddObject(Format('%s, "%s"',
        [ImageData^.Name, ImageData^.Image]), TObject(ImageData));
    end;

    Ini.ReadSection('Font', Str);
    for i:= 0 to Str.Count - 1 do
    begin
      new(FontData);
      FontData^.Name := Ini.ReadString('Font', Str[i], '');
      FontData^.FontName := Ini.ReadString(FontData^.Name, 'name', 'arial');
      FontData^.FontSize := Ini.ReadInteger(FontData^.Name, 'size', 8);
      FontData^.FontColor := WebToColor(Ini.ReadString(FontData^.Name, 'color', '#0'));
      FontData^.FontStyle := StrToFontStyles(Ini.ReadString(FontData^.Name, 'styles', ''));
      ListBox4.Items.AddObject(Format('%s, %s, %d',
        [FontData^.Name, FontData^.FontName, FontData^.FontSize]), TObject(FontData));
    end;

    Str.Free;
    Ini.Free;
  end;
end;

procedure TfrmMain.ini2Click(Sender: TObject);
var
  Ini: TIniFile;
  i: Integer;
  tmp: String;
  c: array[0..5] of CHAR;
begin
  if SaveDialogIni.Execute then
  begin
    Ini := TIniFile.Create(ChangeFileExt(SaveDialogIni.FileName, '.ini'));

    for i:= 0 to ListBox3.Items.Count - 1 do
    with PIntData(ListBox3.Items.Objects[i])^ do
      Ini.WriteString('Constant', Name, Int);

    for i:= 0 to ListBox1.Items.Count - 1 do
    with PColorData(ListBox1.Items.Objects[i])^ do
    begin
      tmp := IntToHex(Color, 6);
      c[0] := tmp[5];
      c[1] := tmp[6];
      c[2] := tmp[3];
      c[3] := tmp[4];
      c[4] := tmp[1];
      c[5] := tmp[2];
      Ini.WriteString('Color', Name, '#' + c);
    end;

    for i:= 0 to ListBox2.Items.Count - 1 do
    with PImageData(ListBox2.Items.Objects[i])^ do
      Ini.WriteString('Image', Name, Image);

    for i:= 0 to ListBox4.Items.Count - 1 do
    with PFontData(ListBox4.Items.Objects[i])^ do
    begin
      Ini.WriteString('Font', IntToStr(i + 1), Name);
      Ini.WriteString(Name, 'name', FontName);
      Ini.WriteInteger(Name, 'size', FontSize);
      tmp := IntToHex(FontColor, 6);
      c[0] := tmp[5];
      c[1] := tmp[6];
      c[2] := tmp[3];
      c[3] := tmp[4];
      c[4] := tmp[1];
      c[5] := tmp[2];
      Ini.WriteString(Name, 'color', '#' + c);
      tmp := '';
      if (fsBold in FontStyle) then
      begin
        if (Length(tmp) > 0) then
        tmp := tmp + ', bold' else
        tmp := 'bold';
      end;
      if (fsItalic in FontStyle) then
      begin
        if (Length(tmp) > 0) then
        tmp := tmp + ', italic' else
        tmp := 'italic';
      end;
      if (fsUnderline in FontStyle) then
      begin
        if (Length(tmp) > 0) then
        tmp := tmp + ', underline' else
        tmp := 'underline';
      end;
      if (fsStrikeout in FontStyle) then
      begin
        if (Length(tmp) > 0) then
        tmp := tmp + ', strikeout' else
        tmp := 'strikeout';
      end;
      Ini.WriteString(Name, 'styles', tmp);
    end;

    Ini.Free;
  end;
end;

procedure TfrmMain.N20Click(Sender: TObject);
begin
  if MessageBox(Handle, ' ?', 'Question', MB_ICONQUESTION or MB_YESNO) <> idYes then Exit;
  dispose(PFontData(ListBox4.Items.Objects[ListBox4.ItemIndex]));
  ListBox4.Items.Delete(ListBox4.ItemIndex);
end;

procedure TfrmMain.PopupMenu4Popup(Sender: TObject);
begin
  N20.Enabled := (ListBox4.ItemIndex >= 0);
  N21.Enabled := N20.Enabled;
end;

procedure TfrmMain.N19Click(Sender: TObject);
var
  FontData: PFontData;
begin
  frmAddFont.CurIndex := -1;
  frmAddFont.Edit1.Text := '';
  frmAddFont.FontDialog.Font.Name := 'Arial';
  frmAddFont.FontDialog.Font.Size := 8;
  frmAddFont.FontDialog.Font.Color := clWindowText;
  frmAddFont.FontDialog.Font.Style := [];
  frmAddFont.Label1.Font.Assign(frmAddFont.FontDialog.Font);
  frmAddFont.Label4.Caption := '';
  frmAddFont.Button2.Enabled := False;
  if (frmAddFont.ShowModal = idOk) then
  begin
    new(FontData);
    FontData^.Name := frmAddFont.Edit1.Text;
    FontData^.FontName := frmAddFont.FontDialog.Font.Name;
    FontData^.FontSize := frmAddFont.FontDialog.Font.Size;
    FontData^.FontColor := frmAddFont.FontDialog.Font.Color;
    FontData^.FontStyle := frmAddFont.FontDialog.Font.Style;
    ListBox4.Items.AddObject(Format('%s, %s, %d',
      [FontData^.Name, FontData^.FontName, FontData^.FontSize]), TObject(FontData));
  end;
end;

procedure TfrmMain.N21Click(Sender: TObject);
var
  FontData: PFontData;
begin
  FontData := PFontData(ListBox4.Items.Objects[ListBox4.ItemIndex]);
  frmAddFont.CurIndex := ListBox4.ItemIndex;
  frmAddFont.Edit1.Text := FontData^.Name;
  frmAddFont.FontDialog.Font.Name := FontData^.FontName;
  frmAddFont.FontDialog.Font.Size := FontData^.FontSize;
  frmAddFont.FontDialog.Font.Color := FontData^.FontColor;
  frmAddFont.FontDialog.Font.Style := FontData^.FontStyle;
  frmAddFont.Label1.Font.Assign(frmAddFont.FontDialog.Font);
  frmAddFont.Label4.Caption := '';
  frmAddFont.Button2.Enabled := True;
  if (frmAddFont.ShowModal = idOk) then
  begin
    FontData^.Name := frmAddFont.Edit1.Text;
    FontData^.FontName := frmAddFont.FontDialog.Font.Name;
    FontData^.FontSize := frmAddFont.FontDialog.Font.Size;
    FontData^.FontColor := frmAddFont.FontDialog.Font.Color;
    FontData^.FontStyle := frmAddFont.FontDialog.Font.Style;
    ListBox4.Items[ListBox4.ItemIndex] := Format('%s, %s, %d',
      [FontData^.Name, FontData^.FontName, FontData^.FontSize]);
  end;
end;

end.
