unit WinLayerLibDesigner;

interface

uses
  Windows, Messages, SysUtils, Controls, Graphics, Classes, Dialogs, DesignIntf,
  DesignEditors, WinLayerCore;

type
  TWinLayerLibFormProperty = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure Edit; override;
  end;

procedure Register;

implementation

procedure Register;         
begin
  RegisterComponentEditor(TWinLayerLib, TWinLayerLibFormProperty);
end;

{ TWinLayerLibFormProperty }

procedure TWinLayerLibFormProperty.Edit;
begin
  ShowMessage('Windows Layer Library for Delphi');
end;

procedure TWinLayerLibFormProperty.ExecuteVerb(Index: Integer);
var
  OpenDialog: TOpenDialog;
begin
   inherited;
   case Index of
      0:
      begin
        OpenDialog := TOpenDialog.Create(NIL);
        OpenDialog.Filter := 'WinLayer Skin (*.wls)|*.wls';
        if OpenDialog.Execute then
        begin
          TWinLayerLib(GetComponent).Open(OpenDialog.FileName);
          Designer.Modified;
        end;
        OpenDialog.Free;
      end;
   end;
end;

function TWinLayerLibFormProperty.GetVerb(Index: Integer): string;
begin
   case Index of
      0:
        Result := 'Open WinLayer Skin';
   end;
end;

function TWinLayerLibFormProperty.GetVerbCount: Integer;
begin
   Result := 1;
end;

end.
